﻿<?xml version="1.0" encoding="utf-8"?>
<Application>
  <DisplayInfo Title="Visual Studio Professional 2017" Publisher="Microsoft" Version="" ReleaseDate="" Suffix="- Universal (Recommended)">
    <UserCategories>
    </UserCategories>
    <SoftwareCategories>
    </SoftwareCategories>
  </DisplayInfo>
  <DeploymentType Title="" Architecture="x86" Technology="Script" DetectionMethod="Script" ContentLocation="\\server01\sources$\Microsoft\Visual Studio 2017 - Install Scripts\{SoftwareVersion}">
    <UninstallCommand>"Deploy-Application.exe" UNINSTALL</UninstallCommand>
    <InstallCommand>"Deploy-Application.exe" INSTALL -Workload "Universal:includeRecommended"</InstallCommand>
    <DetectionScript RunAs32Bit="False" Language="PowerShell">
      <TEXT>{DetectionStatement}

$VisualStudioInstancesPath = "$env:ProgramData\Microsoft\VisualStudio\Packages\_Instances"
$VisualStudioInstancesDir = Get-Item -Path "$env:ProgramData\Microsoft\VisualStudio\Packages\_Instances" -ErrorAction SilentlyContinue
if(!$VisualStudioInstancesDir) {
    return
}
$VisualStudioInstances = $VisualStudioInstancesDir | Get-ChildItem
$Installed = $null
$MultipleInstances = $null
if(($VisualStudioInstances | Measure-Object).Count -eq 0) {
    $Installed = $false
    return
} elseif (($VisualStudioInstances | Measure-Object).Count -eq 1) {
    $Installed = $true
} elseif (($VisualStudioInstances | Measure-Object).Count -gt 1) {
    $Installed = $true
    $MultipleInstances = $true
    return
}

$StateJSON = ConvertFrom-Json -InputObject (Get-Content -Path "$($VisualStudioInstances.FullName)\state.json")
$InstalledWorkload = $StateJSON.selectedPackages | Where-Object {$_.Id -eq $TargetWorkloadId}
if($InstalledWorkload) {
    if([version]$InstalledWorkload.version -ge [version]$TargetWorkloadVersion) {
        if($Recommended -or $Optional) {
            # Check if local version of source catalog exists
            $LocalSourceCatalogPath = "$env:windir\temp\Catalog_$($SourceBuildVersion).json"
            if(!(Test-Path -Path $LocalSourceCatalogPath -ErrorAction SilentlyContinue)) {
                $null = Copy-Item -Path "$VisualStudioSourcePath\Catalog.json" -Destination $LocalSourceCatalogPath -Force
            }
            
            # Read the Catalog JSON so we can reference Optional and Recommended Workload dependencies
            $SourceCatalogJSON = ConvertFrom-Json -InputObject (Get-Content -Path $LocalSourceCatalogPath -Raw)

            $TargetWorkloadList = $SourceCatalogJSON.packages | Where-Object {$_.type -eq 'Workload'}
            $TargetWorkload = $TargetWorkloadList | Where-Object {$_.id -eq $TargetWorkloadId}
            
            # Create a more manageable list out of the dependencies
            $DependencyNameList = $TargetWorkload.dependencies | Get-Member -MemberType NoteProperty | Select-Object -ExpandProperty Name
            $DependencyList = foreach($DependencyName in $DependencyNameList) {
                $DependencyDetails = $TargetWorkload.dependencies.$DependencyName
                $Name = $DependencyName
                if($DependencyDetails.version) {
                    $VersionList = $DependencyDetails.version
                    $Type = $DependencyDetails.type
                } else {
                    $VersionList = $DependencyDetails
                    $Type = 'Required'
                }

                # Get the required dependency version from the source Catalog
                $DependencyVersion = ($SourceCatalogJSON.packages | Where-Object {$_.id -eq $DependencyName}).version

                # Check if this dependency is applicable to currently installed Visual Studio version
                $Applicable = $true
                if($DependencyDetails.when) {
                    if(!($StateJSON.product.id -in $DependencyDetails.when)) {
                        # This dependency is not applicable
                        $Applicable = $false
                    }
                }

                [pscustomobject]@{
                    Name = $DependencyName
                    DependencyVersion = $DependencyVersion
                    VisualStudioVersionList = $VersionList
                    Type = $Type
                    Applicable = $Applicable
                }
            } # END DependencyList
        
            $InstalledComponentList = $StateJSON.selectedPackages | Where-Object {$_.type -eq 'Component'}

			if($Optional) {
                foreach($DependencyItem in ($DependencyList | Where-Object {($_.Applicable) -and ($_.Type -eq 'Optional')})) {
                    $InstalledDependencyItem = $null
                    $InstalledDependencyItem = $InstalledComponentList | Where-Object {$_.id -eq $DependencyItem.Name}
                    if($InstalledDependencyItem) {
                        # Compare versions
                        if([version]$InstalledDependencyItem.version -ge [version]$DependencyItem.DependencyVersion) {
                            # Compliant
                        } else {
                           return
                        }
                    } else {
                        return
                    }
                }
            } # End if($Optional)

            if($Recommended) {
                foreach($DependencyItem in ($DependencyList | Where-Object {($_.Applicable) -and ($_.Type -eq 'Recommended')})) {
                    $InstalledDependencyItem = $null
                    $InstalledDependencyItem = $InstalledComponentList | Where-Object {$_.id -eq $DependencyItem.Name}
                    if($InstalledDependencyItem) {
                        # Compare versions
                        if([version]$InstalledDependencyItem.version -ge [version]$DependencyItem.DependencyVersion) {
                            # Compliant
                        } else {
                           return
                        }
                    } else {
                        return
                    }
                }
            } # End if($Recommended)

            return $true
        } else { 
            return $true
        } # End if($Recommended -or $Optional)
    }
}</TEXT>
    </DetectionScript>
	<Custom>
		<DetectionScriptLogic TargetItemPath="\\server01\sources$\Microsoft\Visual Studio\Professional\2017\{SoftwareVersion}\Catalog.json" >
			<SCRIPT>
$RootPath = $args[0]
$appDT = $args[1]
$appSoftwareVersion = $args[2]
$TargetItemPath = $args[3]
$InstallCommand = $appDT.InstallCommand
$Workload = $InstallCommand.Split('-')[-1].Split()[-1].Trim('"')
$VisualStudioSourcePath = Split-Path -Path ($appDT.Custom.DetectionScriptLogic.TargetItemPath -replace ('{SoftwareVersion}', $appSoftwareVersion))
$SourceBuildVersion = (Get-Item -Path "$VisualStudioSourcePath\vs_setup.exe").VersionInfo.ProductVersion.Trim()

$CatalogPath = "$VisualStudioSourcePath\Catalog.json"
$CatalogContent = Get-Content -Path $CatalogPath -Raw
$CatalogJSON = ConvertFrom-Json -InputObject $CatalogContent
$WorkloadListJSON = $CatalogJSON.packages | Where-Object {$_.type -eq 'Workload'}

if($Workload) {            
	foreach($item in $Workload) {
		$Arguments = $null
		$ItemSplit = $item.Split(':')
		if($ItemSplit.Count -gt 1) {
			$Arguments = ";$($ItemSplit[1..$ItemSplit.Count] -join ';')"
		}
		
		$WorkloadId = $WorkloadListJSON.Id | Where-Object {$_ -like "*$($ItemSplit[0])"}
		$String = "--add $($WorkloadId)$($Arguments) "
		$WorkloadInstallString += $String
		$WorkloadVersion = ($WorkloadListJSON | Where-Object {$_.id -eq $WorkloadId}).version
		if($item -match 'recommended') {
			$Recommended = $true
		} else {
			$Recommended = $false
		}
		
		if($item -match 'optional') {
			$Optional = $true
		} else {
			$Optional = $false
		}
	}
}

$DetectionString = @"
`$TargetWorkloadId = '$WorkloadId'
`$TargetWorkloadIdVersion = '$WorkloadVersion'
`$Recommended = `$$Recommended
`$Optional = `$$Optional
`$VisualStudioSourcePath = '$VisualStudioSourcePath'
`$SourceBuildVersion = '$SourceBuildVersion'
"@

$DetectionString
			</SCRIPT>
		</DetectionScriptLogic>
	</Custom>
  </DeploymentType>
</Application>